// Copyright 2022 The Accumulate Authors
//
// Use of this source code is governed by an MIT-style
// license that can be found in the LICENSE file or at
// https://opensource.org/licenses/MIT.

package config

// GENERATED BY go run ./tools/cmd/gen-enum. DO NOT EDIT.

import (
	"strings"
)

// NodeTypeValidator .
const NodeTypeValidator NodeType = 1

// NodeTypeFollower .
const NodeTypeFollower NodeType = 2

// PortOffsetTendermintP2P .
const PortOffsetTendermintP2P PortOffset = 0

// PortOffsetTendermintRpc .
const PortOffsetTendermintRpc PortOffset = 1

// PortOffsetAccumulateP2P .
const PortOffsetAccumulateP2P PortOffset = 2

// PortOffsetPrometheus .
const PortOffsetPrometheus PortOffset = 3

// PortOffsetAccumulateApi .
const PortOffsetAccumulateApi PortOffset = 4

// NodeTypeByName returns the named Node Type.
func NodeTypeByName(name string) (NodeType, bool) {
	switch strings.ToLower(name) {
	case "validator":
		return NodeTypeValidator, true
	case "follower":
		return NodeTypeFollower, true
	default:
		return 0, false
	}
}

// PortOffsetByName returns the named Port Offset.
func PortOffsetByName(name string) (PortOffset, bool) {
	switch strings.ToLower(name) {
	case "tendermintp2p":
		return PortOffsetTendermintP2P, true
	case "tendermintrpc":
		return PortOffsetTendermintRpc, true
	case "accumulatep2p":
		return PortOffsetAccumulateP2P, true
	case "prometheus":
		return PortOffsetPrometheus, true
	case "accumulateapi":
		return PortOffsetAccumulateApi, true
	default:
		return 0, false
	}
}
